using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Effects;
using Jypeli.Widgets;


namespace Matopeli;

/// @author Omanimi
/// @version 26.10.2023
/// <summary>
/// 
/// </summary>
public class Matopeli : PhysicsGame
{

    private static readonly string[] kentta ={
        "---------------",
        "-             -",
        "-             -",
        "-          o  -",
        "-             -",
        "-             -",
        "-   km        -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "-             -",
        "---------------",
    };
    private int seinaleveys= 600 / kentta.Length;
    private int seinakorkeus = 600 / kentta.Length;

    private static readonly Image seinakuva = LoadImage("seina.png");
    private static readonly Image matopaakuva = LoadImage("matopaa.png");
    private readonly Image matokehokuva = LoadImage("matokeho.png");
    private readonly Image omenakuva = LoadImage("omena.png");
    private readonly Image kenttatausta = LoadImage("kenttatausta.png");
    
    
    
    public readonly IntMeter pisteet = new IntMeter(0);
    private Label pisteNaytto;

    public override void Begin()
    {
        ClearAll();
       // Background.Image = LoadImage("kenttatausta");
        //LuoTausta();
        TileMap seinat = TileMap.FromStringArray(kentta);
        seinat.SetTileMethod('-',LuoSeina);
        seinat.SetTileMethod('m',LuoMatopaa);
        seinat.SetTileMethod('o',LuoOmena);
        seinat.SetTileMethod('k',LuoMatokeho);

        seinat.Execute(seinaleveys, seinakorkeus);

    }

    private void LuoSeina(Vector paikka, double leveys, double korkeus)
        {
            PhysicsObject seina = new PhysicsObject(leveys, korkeus);
            seina.Position = paikka;
            seina.Image = seinakuva;
            Add(seina);
        }
    
    private void LuoOmena(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject omena = new PhysicsObject(leveys, korkeus);
        omena.Position = paikka;
        omena.Image = omenakuva;
        Add(omena);
    }
    
    private void LuoMatopaa(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject matopaa = new PhysicsObject(leveys, korkeus);
        matopaa.Position = paikka;
        matopaa.Image = Matopeli.matopaakuva;
        Add(matopaa);
    }
    
    private void LuoMatokeho(Vector paikka, double leveys, double korkeus)
    {
        PhysicsObject matokeho = new PhysicsObject(leveys, korkeus);
        matokeho.Position = paikka;
        matokeho.Image = matokehokuva;
        Add(matokeho);  
    }
            
    }
